// ___SETA43  _____
// 27/11/2024 _____
// RELOJ DS1307
// Arduino 1.8.19
// RELOJ Raspberry pi pico
// seta43.duckdns.org
// seta43.blogspot.com

#include "Rotary.h"
#include "RTClib.h"

//___________OLED_________
#include "olex.h"
#include <Wire.h>

#define SDA  0
#define SCL  1
/////////////////////////////////////////////////////////////////
#define ROTARY_PIN1 5 
#define ROTARY_PIN2 4  
#define BUTTON_PIN  3 
#define CLICKS_PER_STEP   4   // this number depends on your rotary encoder 

Rotary r;
RTC_DS1307 rtc;
/////////////////////////////////////////////////////////////////

int segundo,minuto,hora,dia,mes;
long anio; //variable año
DateTime HoraFecha;

char Nombres[8][7]= {"*","DIA  ", "MES  ", "A\x7FO  ", "HORA ", "MIN. ",  "SEG. "};

int segundoOld;
char cadena[40];
int modo = 0; 

void setup() 
{
  Serial.begin(9600);
  while (!Serial) {;  }
  delay(500);
  Serial.println("\n\nRELOJ Raspberry pi pico lib_SETA");
  
  pinMode(LED_BUILTIN, OUTPUT);
  pinMode(BUTTON_PIN, INPUT); 

  Wire.setSDA(SDA);
  Wire.setSCL(SCL);
  Wire.begin(); // Wire communication begin
  Wire.setClock(100000);
  
  if (! rtc.begin()) 
        {   
          while (1)  {Serial.println("Couldn't find RTC"); delay(1000); }
        }

  OleInit();
  delay(1000); 
  xclearDisplay(); 
  ModeFont=0; xStringAT(0,0,(char *)"SETA43 RELOJ-DS1307"); 
  
  delay(500);
  
  r.begin(ROTARY_PIN1, ROTARY_PIN2, CLICKS_PER_STEP);
  r.setLeftRotationHandler(showDirection);
  r.setRightRotationHandler(showDirection);

  xclearDisplay();
}



void loop()
{
    delay(10);  
    r.loop();

    if(modo==0)
        {
            HoraFecha = rtc.now(); //obtenemos la hora y fecha actual 
            segundo=HoraFecha.second();
            if(segundo!=segundoOld)
              {  
                digitalWrite(13, !digitalRead(13));  
                segundoOld=segundo;
                minuto=HoraFecha.minute();
                hora=HoraFecha.hour();
                dia=HoraFecha.day();
                mes=HoraFecha.month();
                anio=HoraFecha.year();
                printLinea();
                printPanel();
               }
        }
   
    if (digitalRead(BUTTON_PIN) == 0) 
        {              
          while(digitalRead(BUTTON_PIN) == 0) {;}
          modo = modo + 1;
          if (modo > 6) 
              { 
                modo = 0;
                rtc.adjust(DateTime(anio, mes, dia, hora, minuto, segundo));
              }
          xclearDisplay();
          printLinea(); 
          printPanel();
          Serial.println(modo);
          delay(400);
        }
  
}


////////////RUTINAS/////////////

void printLinea(void)
{
  if(modo!=0) 
  {
    sprintf(cadena,"CAMBIO %s",Nombres[modo]);
    Serial.print(cadena);
  }
  sprintf(cadena,"%02d:%02d:%02d   %02d/%02d/%02d",hora,minuto,segundo,dia,mes,anio);
  Serial.println(cadena);
}


void printPanel(void)
{
 // xclearDisplay(); 

if(modo!=0) 
  {   
    ModeFont=1;
    sprintf(cadena,"->%s",Nombres[modo]);
    xStringAT(0,7,(char *)cadena);
  }


  
  ModeFont=2; 
  sprintf(cadena," %02d:%02d:%02d",hora,minuto,segundo);
  xStringAT(0,0,(char *)cadena);

  sprintf(cadena,"%02d/%02d/%02d",dia,mes,anio);
  xStringAT(0,3,(char *) cadena);
}


void showDirection(Rotary& r) 
{
 int z;
  if(r.getDirection()==1) z=-1; else z=1;

  switch(modo)
    {
      case 1:
          dia+=z;
      break;
      case 2:
          mes+=z;
      break;
      case 3:
          anio+=z;
      break;
      case 4:       
         hora+=z;
      break;
      case 5:       
         minuto+=z;
      break;
      case 6:
        segundo+=z;       
      break;
    }
  printLinea();
  printPanel(); 
}
